# TODO:
# - include examples in package

# Conditional build:
%bcond_without  python2 # Python 2.x version
%bcond_without  python3 # Python 3.x version (available as 'py3lint')
%bcond_without	doc # Documentation

Summary:	Python 2 tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona 2 sprawdzające zgodność modułu ze standardem kodowania
Name:		pylint
Version:	2.2.1
Release:	1
License:	GPL v2+
Group:		Development/Languages/Python
#Source0Download: https://pypi.python.org/pypi/pylint
Source0:	https://github.com/PyCQA/pylint/archive/%{name}-%{version}.tar.gz
# Source0-md5:	3226620b3ec540f9371019b3f4ca87fe
URL:		http://www.pylint.org/
%if %{with python2}
BuildRequires:	python-astroid >= 1.5.3
BuildRequires:	python-certifi >= 2017.4.17
BuildRequires:	python-chardet >= 3.0.2
BuildRequires:	python-devel
BuildRequires:	python-idna >= 2.5
BuildRequires:	python-isort
BuildRequires:	python-lazy-object-proxy
BuildRequires:	python-mccabe
BuildRequires:	python-modules >= 1:2.5
BuildRequires:	python-setuptools >= 7.0
BuildRequires:	python-wrapt
#BuildConflicts:	python-chardet >= 3.1.0
#BuildConflicts:	python-idna >= 2.7
%endif
%if %{with python3}
BuildRequires:	python3-2to3
BuildRequires:	python3-astroid >= 1.5.3
BuildRequires:	python3-certifi >= 2017.4.17
BuildRequires:	python3-chardet >= 3.0.2
BuildRequires:	python3-devel
BuildRequires:	python3-idna >= 2.5
BuildRequires:	python3-isort
BuildRequires:	python3-lazy-object-proxy
BuildRequires:	python3-mccabe
BuildRequires:	python3-modules >= 1:3.2
BuildRequires:	python3-setuptools >= 7.0
BuildRequires:	python3-wrapt
#BuildConflicts:	python3-chardet >= 3.1.0
#BuildConflicts:	python3-idna >= 2.7
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
BuildRequires:	sphinx-pdg
Requires:	python-pylint = %{version}-%{release}
Suggests:	python-devel-src
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# /etc/pylintrc is deliberately packaged to both packages with same name
%define		_duplicate_files_terminate_build	0

# current Python 3.x provides all these
%define		_noautoreq	python3egg.backports.functools-lru-cache python3egg.configparser python3egg.singledispatch

%description
Python 2 tool that checks if a module satisfy a coding standard.

%description -l pl.UTF-8
Narzędzie Pythona 2 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

%package -n python-pylint
Summary:	Python 2 tool that checks if a module satisfy a coding standard (modules)
Summary(pl.UTF-8):	Narzędzie Pythona sprawdzające zgodność modułu ze standardem kodowania (moduły)
Group:		Libraries/Python

%description -n python-pylint
Python 2 tool that checks if a module satisfy a coding standard.

This package contains only the Python modules used by the tool.

%description -n python-pylint -l pl.UTF-8
Narzędzie Pythona 2 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Ten pakiet zawiera tylko moduły Pythona używane przez to narzędzie.

%package -n py3lint
Summary:	Python 3 tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania
Group:		Development/Languages/Python
Requires:	python3-pylint = %{version}-%{release}
Obsoletes:	pylint-python3 < 1.0.0-2

%description -n py3lint
Python 3 tool that checks if a module satisfy a coding standard.

Python 3.x version, available via the 'py3lint' command.

%description -n py3lint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Wersja dla Pythona 3.x, dostępna przez polecenie 'py3lint'.

%package -n python3-pylint
Summary:	Python 3 tool that checks if a module satisfy a coding standard (moduły)
Summary(pl.UTF-8):	Narzędzie Pythona 3 sprawdzające zgodność modułu ze standardem kodowania (modules)
Group:		Libraries/Python

%description -n python3-pylint
Python 3 tool that checks if a module satisfy a coding standard.

This package contains only the Python modules used by the tool.

%description -n python3-pylint -l pl.UTF-8
Narzędzie Pythona 3 sprawdzające zgodność modułów napisanych w języku
Python z regułami tworzenia kodu źródłowego.

Ten pakiet zawiera tylko moduły Pythona używane przez to narzędzie.

%prep
%setup -q -n pylint-pylint-%{version}

%build
%if %{with python2}
%py_build
%endif

%if %{with python3}
%py3_build
%endif

%if %{with doc}
%{__make} -C doc text \
	PYTHONPATH=$PWD
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_mandir}/man1}

%if %{with python3}
%py3_install

%{__mv} $RPM_BUILD_ROOT%{_bindir}/epylint $RPM_BUILD_ROOT%{_bindir}/epy3lint
%{__mv} $RPM_BUILD_ROOT%{_bindir}/pylint $RPM_BUILD_ROOT%{_bindir}/py3lint
%{__mv} $RPM_BUILD_ROOT%{_bindir}/pyreverse $RPM_BUILD_ROOT%{_bindir}/py3reverse
cp -p man/epylint.1 $RPM_BUILD_ROOT%{_mandir}/man1/epy3lint.1
cp -p man/pylint.1 $RPM_BUILD_ROOT%{_mandir}/man1/py3lint.1
cp -p man/pyreverse.1 $RPM_BUILD_ROOT%{_mandir}/man1/py3reverse.1
%endif

%if %{with python2}
%py_install
%py_postclean
cp -p man/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
%endif

cp -p examples/pylintrc $RPM_BUILD_ROOT%{_sysconfdir}/pylintrc

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc ChangeLog README.rst examples/*
%{?with_doc:%doc doc/_build/text/*.txt}
%attr(755,root,root) %{_bindir}/epylint
%attr(755,root,root) %{_bindir}/pylint
%attr(755,root,root) %{_bindir}/pyreverse
%attr(755,root,root) %{_bindir}/symilar
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc
%{_mandir}/man1/epylint.1*
%{_mandir}/man1/pylint.1*
%{_mandir}/man1/pyreverse.1*
%{_mandir}/man1/symilar.1*

%files -n python-pylint
%defattr(644,root,root,755)
%{py_sitescriptdir}/pylint
%{py_sitescriptdir}/pylint-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n py3lint
%defattr(644,root,root,755)
%doc ChangeLog README.rst examples/*
%{?with_doc:%doc doc/_build/text/*.txt}
%attr(755,root,root) %{_bindir}/epy3lint
%attr(755,root,root) %{_bindir}/py3lint
%attr(755,root,root) %{_bindir}/py3reverse
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc
%{_mandir}/man1/epy3lint.1*
%{_mandir}/man1/py3lint.1*
%{_mandir}/man1/py3reverse.1*

%files -n python3-pylint
%defattr(644,root,root,755)
%{py3_sitescriptdir}/pylint
%{py3_sitescriptdir}/pylint-%{version}-py*.egg-info
%endif
%changelog
* Tue Nov 27 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pylint.git;a=log;h=master

* Tue Nov 27 2018 Adam Gołębiowski <adamg@pld-linux.org> 9dc373f
- updated to 2.2.1

* Mon Nov 26 2018 Adam Gołębiowski <adamg@pld-linux.org> 3999ed4
- updated to 2.2.0

* Fri Aug 31 2018 Marcin Krol <hawk@tld-linux.org> e0de7fe
- updated to 2.1.1, added doc bcond

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 0643f9b
- release 2 (by relup.sh)

* Thu Mar 15 2018 Marcin Krol <hawk@tld-linux.org> 23f8b7d
- oh well, updated to 1.8.2

* Thu Mar 15 2018 Marcin Krol <hawk@tld-linux.org> 19641c0
- updated to 1.7.6, updated BRs, updated source URL

* Fri Nov 24 2017 Jacek Konieczny <j.konieczny@eggsoft.pl> bc8a899
- Version: 1.7.4

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 0ea8b4f
- python 3.6
- release 3 (by relup.sh)

* Fri Dec 11 2015 Jakub Bogusz <qboosh@pld-linux.org> df0ba44
- mention python version in descriptions

* Mon Dec 07 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 345b7a9
- Move python modules to separate packages

* Mon Dec 07 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 15bfcc2
- Version: 1.5.1

* Mon Sep 14 2015 Elan Ruusamäe <glen@delfi.ee> dab1381
- python3 rebuild
- release 3 (by relup.sh)

* Mon Sep 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> d10cd6d
- release 2 (by relup.sh)

* Wed Jun 17 2015 Jakub Bogusz <qboosh@pld-linux.org> 6ea1b8d
- noted download URL

* Mon Jun 15 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> e1ce958
- Fix doc buildinig when pylint is not installed

* Thu Jun 11 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 71480d3
- Version: 1.4.3

* Mon May 04 2015 Jan Rękorajski <baggins@pld-linux.org> bb2079e
- x32 rebuild
- release 2 (by relup.sh)

* Thu Nov 27 2014 Jakub Bogusz <qboosh@pld-linux.org> 61aac75
- updated astroid version; needs six now

* Tue Nov 25 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ae8aadb
- up to 1.4.0

* Sun Oct 19 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 738e20e
- python 3.4
- release 2 (by relup.sh)

